<?php

  class mw_users_morceaux extends mw_controller{

    var $user;

    var $status;
    var $album_status_id;
    var $morceau_status_id;

    function validate(){
      $env = $this->env();
      $data = $env->data();
      if(($this->status = $data->source_status()) === false){
        return "Impossible de lire la liste des status de source";
      }
      foreach($this->status as $id_source_status => $source_status){
        if($source_status["nom"] == "album") $this->album_status_id = $id_source_status;
        if($source_status["nom"] == "morceau") $this->morceau_status_id = $id_source_status;
        if(isset($this->album_status_id) && isset($this->morceau_status_id)) break;
      }
      if(!isset($this->album_status_id) || !isset($this->morceau_status_id)){
        if(!isset($this->album_status_id)) return "Type de source inconnu: album";
        return "Type de source inconnu: morceau";
      }
      if(!($this->user = $env->user())){
        return "Vous devez être identifié pour accéder à cette page";
      }
      return true;
    }

    function index(){
      $env = $this->env();
      $data = $env->data();
      if(($groupes = $data->groupes($this->user["id"])) === false){
        $env->erreur("Impossible de lire la liste des groupes");
        return;
      }
      $albums_groupes = $groupes["list"];
      $id_groupe = false;
      if(isset($_GET[$env->param("groupe")])){
        $id_groupe = $_GET[$env->param("groupe")];
        if(!isset($groupes["list"][$id_groupe])){
          $env->erreur("Impossible de lire les informations du groupe");
          return;
        }
      }
      if($id_groupe){
        $albums_groupes = array($id_groupe => $groupes["list"][$id_groupe]);
      }
      if(
        (
          $albums = $data->groupes_sources(
            array(
              "groupes" => $albums_groupes,
              "id_class" => $this->album_status_id,
              // on veut les albums pour lesquels au moins un groupe (et pas tous) ...
              "satisfy_all_groupes_access" => false,
              // ... a le droit de contribution
              "id_source_access" => $data->id_groupe_status_contributeur()
            )
          )
        ) === false
      ) return "impossible de lire la liste des albums";
      if($id_album = isset($_GET[$env->param("album")]) ? $_GET[$env->param("album")] : false){
        if(!($album = $data->source($id_album, true))){
          $env->erreur("Impossible de lire les informations de l'album");
          return;
        }
      }
      $select = array(
        "status" => $this->morceau_status_id,
        "id_user" => $this->user["id"],
        "order_by" => "ordre",
        "start" => isset($_GET[$env->param("start")]) && $_GET[$env->param("start")] ? $_GET[$env->param("start")] : 0
      );
      if($id_groupe) $select["id_groupe"] = $id_groupe;
      if($id_album !== false) $select["id_composition"] = $id_album;
      if(($morceaux = $data->sources($select)) === false){
        $env->erreur("impossible de lire la liste des morceaux");
        return;
      }
      foreach($morceaux["list"] as $id_morceau => $morceau){
        $morceaux["list"][$id_morceau]["permissions"] = $data->source_permissions($morceau, $this->user["id"]);
      }
      if($_POST){
        foreach($morceaux["list"] as $id_morceau => $morceau){
          if(isset($_POST["ordre_".$id_morceau])){
            if($data->set_source_info($morceau["id"], "ordre", $_POST["ordre_".$id_morceau]) === false){
              $env->erreur("Impossible d'enregistrer l'ordre des morceaux");
              return;
            }
          }
        }
        $get_params = array();
        if($id_groupe) $get_params["groupe"] = $id_groupe;
        if($id_album) $get_params["album"] = $id_album;
        $env->redirect(
          $env->url("users/morceaux", $get_params),
          "l'ordre des morceaux a été enregistré"
        );
      }
      $env->set_out("groupes", $groupes);
      $env->set_out("albums", $albums);
      $env->set_out("morceaux", $morceaux);
    }

    function add(){
      $env = $this->env();
      $data = $env->data();
      $morceau = $data->empty_source();
      $source_infos = array(
        "date_inscription" => date("Y-m-d"),
        "ordre" => 0
      );
      $groupe = false;
      $album = false;
      if(($groupes = $data->groupes($this->user["id"])) === false){
        $env->erreur("Impossible de lire la liste des groupes");
        return;
      }
      $albums = array();
      if($groupes["total"] > 0){
        $select = array(
          "status" => $this->album_status_id,
          "id_user" => $this->user["id"]
        );
        foreach($groupes["list"] as $id_groupe => $groupe){
          $select["id_groupe"] = $id_groupe;
          if(($groupes_albums = $data->sources($select)) === false){
            $env->erreur("impossible de lire la liste des albums");
            return;
          }
          $albums[$id_groupe] = $groupes_albums["list"];
        }
      }
      if(($licences = $data->licences()) === false){
        return "Impossible de lire la liste des licences";
      }
      if(!$data->check_user_uploads_dir()){
        $env->erreur("Impossible de creer le repertoire utilisateur");
        return;
      }
      $web_path = $env->path("web");
      $upload_dir = $env->path("content")."uploads/".$this->user["id"];
      $_SESSION["upload_dir"] = $web_path.($web_path ? "" : "/").$env->path("content")."uploads/".$this->user["id"];
      $users_sources_mod = $env->get_controller("users/sources");
      if($_POST){
        if(!($groupe = $data->groupe($_POST["id_groupe"]))){
          $env->erreur("Impossible de lire les informations du groupe");
          return;
        }
        $groupe["id_groupe_status"] = $data->id_groupe_status_admin();
        $morceau["groupes"] = array($groupe["id"] => $groupe);
        if($_POST["album"]){
          if(!($album = $data->source($_POST["album"], true))){
            $env->erreur("Impossible de lire les informations de l'album");
            return;
          }
          $album["permissions"] = $data->source_permissions($album, $this->user["id"]);
          if(!$album["permissions"]["contributeur"]){
            $env->erreur("vous n'avez pas la permission d'ajouter un morceau dans cet album");
            return;
          }
          $morceau["album"] = $album["id"];
        }
        if(isset($_POST["is_derivation"])){
          foreach($_POST as $key => $value){
            if(substr($key, 0, 14) == "derivation_id_"){
              $id_source_derivation = substr($key, 14);
              $xml_url = trim($_POST["derivation_".$id_source_derivation]);
              $morceau["derivations"][$id_source_derivation] = $users_sources_mod->get_source_from_xml(
                $env,
                $xml_url,
                (
                  isset($_POST["use_edit_derivation_content_".$id_source_derivation]) ?
                    $_POST["edit_derivation_content_".$id_source_derivation]
                  : ($xml_url ? $data->get_source_xml_from_url($xml_url) : "")
                ),
                isset($_POST["use_edit_derivation_content_".$id_source_derivation]) ? true : false
              );
            }
          }
        }
        if(isset($_POST["is_reference"])){
          $xml_url = trim($_POST["reference"]);
          $morceau["reference"] = $users_sources_mod->get_source_from_xml(
            $env,
            $xml_url,
            (
              isset($_POST["use_edit_reference_content"]) ?
                $_POST["edit_reference_content"]
              : ($xml_url ? $data->get_source_xml_from_url($xml_url) : "")
            ),
            isset($_POST["use_edit_reference_content"]) ? true : false
          );
        }
        else{
          if(!($morceau["titre"] = trim($_POST["titre"]))){
            $env->message("merci de pr&eacute;ciser un titre pour le morceau");
          }
          $morceau["licence"] = array(
            "id" => $_POST["licence"]
          );
          $source_infos["date_creation"] = $_POST["annee_date_creation"]."-".$_POST["mois_date_creation"]."-".$_POST["jour_date_creation"];
          $source_infos["description"] = $_POST["description"];
          foreach($_POST as $post_key => $post_value){
            if(substr($post_key, 0, 13) == "document_nom_"){
              if($id_document = substr($post_key, 13)){
                $morceau["documents"][$id_document] = array(
                  "nom" => $_POST["document_nom_".$id_document],
                  "url" => $_POST["document_url_".$id_document]
                );
              }
            }
          }
        }
        if(!$env->messages()){
          if(($image = $data->upload("image", $upload_dir)) === false){
            $env->erreur("erreur lors de l'envoi de l'image. le morceau n'a pas été ajouté");
            return;
          }
          if($image) $source_infos["image"] = $this->user["id"]."/".$image;
          if(
            (
              $id_source = $data->add_source(
                $morceau["groupes"],
                $morceau["titre"],
                $this->morceau_status_id,
                $morceau["licence"]["id"],
                $morceau["documents"],
                $morceau["reference"],
                $morceau["derivations"],
                $source_infos
              )
            ) === false
          ){
            $env->erreur("Impossible d'ajouter le morceau");
            return;
          }
          if($album){
            if(!$data->set_source_composition($id_source, $album["id"])){
              $env->erreur("Le morceau a été ajouté mais impossible de l'associer à l'album");
              return;
            }
          }
          $env->redirect(
            $env->url("users/morceaux"),
            "le morceau a été ajouté"
          );
        }
      }
      $env->set_out("groupes", $groupes);
      $env->set_out("albums", $albums);
      $env->set_out("licences", $licences);
      $env->set_out("morceau", $morceau);
      $env->set_out("source_infos", $source_infos);
      $env->set_out("groupe", $groupe);
      $env->set_out("album", $album);
    }

    function edit(){
      $env = $this->env();
      $data = $env->data();
      if(($groupes = $data->groupes($this->user["id"])) === false){
        $env->erreur("Impossible de lire la liste des groupes");
        return;
      }
      if(($licences = $data->licences()) === false){
        $env->erreur("Impossible de lire la liste des licences");
        return;
      }
      if(($sources_access = $data->sources_access()) === false){
        $env->erreur("Impossible de lire les types d'access");
        return;
      }
      if(!($morceau = $data->source($_GET[$env->param("id")], true))){
        $env->erreur("Impossible de lire les informations du morceau");
        return;
      }
      $morceau["permissions"] = $data->source_permissions($morceau, $this->user["id"]);
      if(!$morceau["permissions"]["editeur"]){
        $env->erreur("vous n'avez pas la permission d'editer ce morceau");
        return;
      }
      if(
        (
          $albums = $data->groupes_sources(
            array(
              "groupes" => $morceau["groupes"],
              "id_class" => $this->album_status_id,
              // on veut les albums pour lesquels chaque groupe du morceau ...
              "satisfy_all_groupes_access" => true,
              // ... a le droit de contribution
              "id_source_access" => $data->id_groupe_status_contributeur()
            )
          )
        ) === false
      ) return "impossible de lire la liste des albums";
      if(!$data->check_user_uploads_dir()){
        $env->erreur("Impossible de creer le repertoire utilisateur");
        return;
      }
      $web_path = $env->path("web");
      $upload_dir = $env->path("content")."uploads/".$this->user["id"];
      $_SESSION["upload_dir"] = $web_path.($web_path ? "" : "/").$env->path("content")."uploads/".$this->user["id"];
      if(($compositions = $data->source_compositions(array("id_source" => $morceau["id"]))) === false){
        $env->erreur("Impossible de lire la liste des compositions");
        return;
      }
      if($compositions) foreach($compositions[$morceau["id"]] as $id_album) { $morceau["album"] = $id_album; break; }
      if($_POST){
        $source_infos = array(
          "date_inscription" => $_POST["date_inscription"],
          "ordre" => isset($morceau["ordre"]) ? $morceau["ordre"] : 0
        );
        $morceau = $data->empty_source(
          array(
            "id" => $morceau["id"],
            "groupes" => $morceau["groupes"],
            "image" => isset($morceau["image"]) ? $morceau["image"] : ""
          )
        );
        $users_sources_mod = $env->get_controller("users/sources");
        if($_POST["album"]){
          if($album = $data->source($_POST["album"], true)){
            $album["permissions"] = $data->source_permissions($album, $this->user["id"]);
            if(!$album["permissions"]["contributeur"]){
              $env->erreur("vous n'avez pas la permission d'ajouter un morceau dans cet album");
              return;
            }
          }
          else{
            $env->erreur("Impossible de lire les informations de l'album");
            return;
          }
          $morceau["album"] = $album["id"];
        }
        if(isset($_POST["is_derivation"])){
          foreach($_POST as $key => $value){
            if(substr($key, 0, 14) == "derivation_id_"){
              $id_source_derivation = substr($key, 14);
              $xml_url = trim($_POST["derivation_".$id_source_derivation]);
              $morceau["derivations"][$id_source_derivation] = $users_sources_mod->get_source_from_xml(
                $env,
                $xml_url,
                (
                  isset($_POST["use_edit_derivation_content_".$id_source_derivation]) ?
                    $_POST["edit_derivation_content_".$id_source_derivation]
                  : ($xml_url ? $data->get_source_xml_from_url($xml_url) : "")
                ),
                isset($_POST["use_edit_derivation_content_".$id_source_derivation]) ? true : false
              );
            }
          }
        }
        if(isset($_POST["is_reference"])){
          $xml_url = trim($_POST["reference"]);
          $morceau["reference"] = $users_sources_mod->get_source_from_xml(
            $env,
            $xml_url,
            (
              isset($_POST["use_edit_reference_content"]) ?
                $_POST["edit_reference_content"]
              : ($xml_url ? $data->get_source_xml_from_url($xml_url) : "")
            ),
            isset($_POST["use_edit_reference_content"]) ? true : false
          );
        }
        else{
          if(!($morceau["titre"] = trim($_POST["titre"]))){
            $env->message("merci de pr&eacute;ciser un titre pour le morceau");
          }
          $morceau["licence"] = array(
            "id" => $_POST["licence"]
          );
          $source_infos["date_creation"] = $_POST["annee_date_creation"]."-".$_POST["mois_date_creation"]."-".$_POST["jour_date_creation"];
          $source_infos["description"] = $_POST["description"];
          foreach($_POST as $post_key => $post_value){
            if(substr($post_key, 0, 13) == "document_nom_"){
              if($id_document = substr($post_key, 13)){
                $morceau["documents"][$id_document] = array(
                  "nom" => $_POST["document_nom_".$id_document],
                  "url" => $_POST["document_url_".$id_document]
                );
              }
            }
          }
        }
        if(!$env->messages()){
          if(isset($_POST["del_image"])){
            if($morceau["image"]){
              if(!@unlink($env->path("content")."uploads/".$morceau["image"])){
                $env->erreur("Impossible d'effacer l'image du morceau");
                return;
              }
            }
            $morceau["image"] = "";
          }
          else{
            if(($up_image = $data->upload("image", $upload_dir)) === false){
              $env->erreur("Impossible d'uploader l'image");
              return;
            }
            if($up_image) $morceau["image"] = $this->user["id"]."/".$up_image;
          }
          if($morceau["image"]) $source_infos["image"] = $morceau["image"];
          if(
            (
              $data->set_source(
                $morceau["id"],
                $morceau["groupes"],
                $morceau["titre"],
                $this->morceau_status_id,
                $morceau["licence"]["id"],
                $morceau["documents"],
                $morceau["reference"],
                $morceau["derivations"],
                $source_infos
              )
            ) === false
          ){
            $env->erreur("Impossible de modifier le morceau");
            return;
          }
          if(!$data->del_source_compositions(array("id_source" => $morceau["id"]))){
            $env->erreur("Le morceau a été modifié mais impossible de l'associer à cet album");
            return;
          }
          if($_POST["album"]){
            if(!$data->set_source_composition($morceau["id"], $_POST["album"])){
              $env->erreur("Le morceau a été modifié mais impossible de l'associer à cet album");
              return;
            }
          }
          $env->redirect(
            $env->url("users/morceaux/edit", array("id" => $morceau["id"])),
            "le morceau a &eacute;t&eacute; modifi&eacute;"
          );
        }
      }
      $env->set_out("groupes", $groupes);
      $env->set_out("sources_access", $sources_access);
      $env->set_out("licences", $licences);
      $env->set_out("albums", $albums);
      $env->set_out("morceau", $morceau);
    }

    function maj_xml(){
      $data = $env->data();
      if(!($morceau = $data->source($_GET[$env->param("id")], true))){
        $env->erreur("Impossible de lire les informations du morceau");
        return;
      }
      $morceau["permissions"] = $data->source_permissions($morceau, $this->user["id"]);
      if(!$morceau["permissions"]["editeur"]){
        $env->erreur("vous n'avez pas la permission d'editer ce morceau");
        return;
      }
      if
      (    isset($_GET[$env->param("id")])
        && isset($_GET[$env->param("xml")])
        && ($_GET[$env->param("xml")] == "derviation" ? isset($_GET[$env->param("derivation")]) : true)
      ){
        $env->erreur("parametre de fichier xml manquant");
        return;
      }
      $xml_url = "";
      if($_GET[$env->param("xml")] == "derivation"){
        if(isset($morceau["derivations"][$_GET[$env->param("derivation")]]["xml"]["url"]))
        $xml_url = $morceau["derivations"][$_GET[$env->param("derivation")]]["xml"]["url"];
      }
      elseif($_GET[$env->param("xml")] == "reference"){
        if(isset($morceau["reference"]["xml"]["url"]))
        $xml_url = $morceau["reference"]["xml"]["url"];
      }
      if(!$xml_url){
        $env->message("Pas d'URL pour ce fichier XML. Impossible de recharger les informations");
        return;
      }
      if(!$env->messages()){
        if(($res = $data->maj_source_cache($xml_url)) === false){
          $env->erreur("Impossible de mettre à jour le contenu du fichier XML dans le cache");
          return;
        }
        if($res === true){
          if($morceau = $data->source($morceau["id"])){
            $env->redirect(
              $env->url("users/morceaux/edit", array("id" => $morceau["id"])),
              "Les informations du fichier XML ont été mises à jour",
              2
            );
          }
          else{
            $env->erreur(
             "le contenu du fichier XML a &eacute;t&eacute; mis &agrave; jour"
            .", mais impossible de lire les informations du morceau"
            );
          }
          return;
        }
        switch($res){
          case -1: $env->message("Impossible de lire le contenu du fichier XML"); break;
          case -2: $env->message("Le fichier XML indiqu&eacute; ne contient pas un fichier de source valide"); break;
          default: $env->erreur("Erreur inconnue (?)"); return;
        }
      }
      $env->run("users/morceaux/edit", array("get" => array("id" => $morceau["id"])));
    }

    function del(){
      $env = $this->env();
      $data = $env->data();
      if(!($morceau = $data->source($_GET[$env->param("id")], true))){
        $env->erreur("Impossible de lire les informations du morceau");
        return;
      }
      $morceau["permissions"] = $data->source_permissions($morceau, $this->user["id"]);
      if(!$morceau["permissions"]["admin"]){
        $env->erreur("vous n'avez pas la permission d'effacer ce morceau");
        return;
      }
      if(!$data->del_source($morceau["id"])){
        $env->erreur("Impossible de supprimer le morceau");
        return;
      }
      $env->redirect(
        $env->url("users/morceaux"),
        "le morceau a été supprimé"
      );
    }

  }

?>